/***************************************************************************
 *   Project TUPI: Magia 2D                                                *
 *   Project Contact: info@maefloresta.com                                 *
 *   Project Website: http://www.maefloresta.com                           *
 *   Project Leader: Gustav Gonzalez <info@maefloresta.com>                *
 *                                                                         *
 *   Developers:                                                           *
 *   2010:                                                                 *
 *    Gustavo Gonzalez / xtingray                                          *
 *                                                                         *
 *   KTooN's versions:                                                     * 
 *                                                                         *
 *   2006:                                                                 *
 *    David Cuadrado                                                       *
 *    Jorge Cuadrado                                                       *
 *   2003:                                                                 *
 *    Fernado Roldan                                                       *
 *    Simena Dinas                                                         *
 *                                                                         *
 *   Copyright (C) 2010 Gustav Gonzalez - http://www.maefloresta.com       *
 *   License:                                                              *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>. *
 ***************************************************************************/

#ifndef TSTACKEDMAINWINDOW_H
#define TSTACKEDMAINWINDOW_H

#include "tmainwindow.h"

#include <QHash>

class QStackedWidget;

/**
 * @author David Cuadrado
*/

class T_IDEAL_EXPORT TStackedMainWindow : public TMainWindow
{
    Q_OBJECT

    public:
        TStackedMainWindow(QWidget *parent = 0);
        ~TStackedMainWindow();
        void addWidget(QWidget *widget, int perspective = DefaultPerspective);
        void removeWidget(QWidget *widget);
        
    private slots:
        void setupPerspective(int perspective);
        
    private:
        QStackedWidget *m_stack;
        QHash<int, QWidget *> m_widgets;
};

#endif
